Package org.optaplanner.core.api.domain.common

## Enum DomainAccessType

- java.lang.Object
- - java.lang.Enum<DomainAccessType>
  - - org.optaplanner.core.api.domain.common.DomainAccessType

- All Implemented Interfaces:
    `Serializable`, `Comparable<DomainAccessType>`

      public enum DomainAccessType
      extends Enum<DomainAccessType>

  Determines how members (fields and methods) of the domain (for example the `planner variable`) are accessed.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `GIZMO` | Use Gizmo generated bytecode to access members (fields and methods) to avoid reflection for additional performance.
    `REFLECTION` | Use reflection to read/write members (fields and methods) of the domain.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DomainAccessType` | `valueOf​(String name)` | Returns the enum constant of this type with the specified name.
    `static DomainAccessType[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### REFLECTION

          public static final DomainAccessType REFLECTION

      Use reflection to read/write members (fields and methods) of the domain.

      When used in a modulepath, the module must be open. When used in GraalVM, the domain must be open for reflection.

      This is the default, except with optaplanner-quarkus.

    - #### GIZMO

          public static final DomainAccessType GIZMO

      Use Gizmo generated bytecode to access members (fields and methods) to avoid reflection for additional performance.

      With optaplanner-quarkus, this bytecode is generated at build time and it supports planning annotations on non-public members too.

      Without optaplanner-quarkus, this bytecode is generated at bootstrap runtime and you must add Gizmo in your classpath or modulepath and use planning annotations on public members only.

  - ### Method Detail

    - #### values

          public static DomainAccessType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (DomainAccessType c : DomainAccessType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static DomainAccessType valueOf​(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null